diff --git a/gcc/testsuite/g++.target/i386/pr103973-1.C b/gcc/testsuite/g++.target/i386/pr103973-1.C
index 77f8b4ea325..d7e2e89d895 100644
--- a/gcc/testsuite/g++.target/i386/pr103973-1.C
+++ b/gcc/testsuite/g++.target/i386/pr103973-1.C
@@ -1,8 +1,8 @@
 // PR target/103973
 // { dg-do run }
 // { dg-options "-O2 -std=c++20 -save-temps" }
-// { dg-final { scan-assembler-not "'\tucomisd" { target { ! ia32 } } } }
-// { dg-final { scan-assembler-times "\tcomisd" 2 { target { ! ia32 } } } }
+// { dg-final { scan-assembler-not "'\t\[v\]?ucomisd" { target { ! ia32 } } } }
+// { dg-final { scan-assembler-times "\t\[v\]?comisd" 2 { target { ! ia32 } } } }
 
 #include <compare>
 
diff --git a/gcc/testsuite/g++.target/i386/pr103973-11.C b/gcc/testsuite/g++.target/i386/pr103973-11.C
index 549c1cc0027..535de21ce86 100644
--- a/gcc/testsuite/g++.target/i386/pr103973-11.C
+++ b/gcc/testsuite/g++.target/i386/pr103973-11.C
@@ -1,8 +1,8 @@
 // PR target/103973
 // { dg-do run }
 // { dg-options "-O2 -save-temps -std=c++20" }
-// { dg-final { scan-assembler-not "'\tucomiss" { target { ! ia32 } } } }
-// { dg-final { scan-assembler-times "\tcomiss" 2 { target { ! ia32 } } } }
+// { dg-final { scan-assembler-not "'\t\[v\]?ucomiss" { target { ! ia32 } } } }
+// { dg-final { scan-assembler-times "\t\[v\]?comiss" 2 { target { ! ia32 } } } }
 
 #define double_type float
 #include "pr103973-9.C"
diff --git a/gcc/testsuite/g++.target/i386/pr103973-13.C b/gcc/testsuite/g++.target/i386/pr103973-13.C
index fdd13b99795..a3d4ac5048a 100644
--- a/gcc/testsuite/g++.target/i386/pr103973-13.C
+++ b/gcc/testsuite/g++.target/i386/pr103973-13.C
@@ -1,8 +1,8 @@
 // PR target/103973
 // { dg-do run }
 // { dg-options "-O2 -ffast-math -std=c++20 -save-temps" }
-// { dg-final { scan-assembler-not "'\tucomisd" { target { ! ia32 } } } }
-// { dg-final { scan-assembler-times "\tcomisd" 2 { target { ! ia32 } } } }
+// { dg-final { scan-assembler-not "'\t\[v\]?ucomisd" { target { ! ia32 } } } }
+// { dg-final { scan-assembler-times "\t\[v\]?comisd" 2 { target { ! ia32 } } } }
 
 #include <compare>
 
diff --git a/gcc/testsuite/g++.target/i386/pr103973-15.C b/gcc/testsuite/g++.target/i386/pr103973-15.C
index 1b20b12f934..4143d39edc5 100644
--- a/gcc/testsuite/g++.target/i386/pr103973-15.C
+++ b/gcc/testsuite/g++.target/i386/pr103973-15.C
@@ -1,8 +1,8 @@
 // PR target/103973
 // { dg-do run }
 // { dg-options "-O2 -ffast-math -save-temps -std=c++20" }
-// { dg-final { scan-assembler-not "'\tucomiss" { target { ! ia32 } } } }
-// { dg-final { scan-assembler-times "\tcomiss" 2 { target { ! ia32 } } } }
+// { dg-final { scan-assembler-not "'\t\[v\]?ucomiss" { target { ! ia32 } } } }
+// { dg-final { scan-assembler-times "\t\[v\]?comiss" 2 { target { ! ia32 } } } }
 
 #define double_type float
 #include "pr103973-13.C"
diff --git a/gcc/testsuite/g++.target/i386/pr103973-3.C b/gcc/testsuite/g++.target/i386/pr103973-3.C
index 3d4476cbc17..9ff1c5c527b 100644
--- a/gcc/testsuite/g++.target/i386/pr103973-3.C
+++ b/gcc/testsuite/g++.target/i386/pr103973-3.C
@@ -1,8 +1,8 @@
 // PR target/103973
 // { dg-do run }
 // { dg-options "-O2 -save-temps -std=c++20" }
-// { dg-final { scan-assembler-not "'\tucomiss" { target { ! ia32 } } } }
-// { dg-final { scan-assembler-times "\tcomiss" 2 { target { ! ia32 } } } }
+// { dg-final { scan-assembler-not "'\t\[v\]?ucomiss" { target { ! ia32 } } } }
+// { dg-final { scan-assembler-times "\t\[v\]?comiss" 2 { target { ! ia32 } } } }
 
 #define double_type float
 #include "pr103973-1.C"
diff --git a/gcc/testsuite/g++.target/i386/pr103973-5.C b/gcc/testsuite/g++.target/i386/pr103973-5.C
index b198fe6ad2c..73326984f4e 100644
--- a/gcc/testsuite/g++.target/i386/pr103973-5.C
+++ b/gcc/testsuite/g++.target/i386/pr103973-5.C
@@ -1,8 +1,8 @@
 // PR target/103973
 // { dg-do run }
 // { dg-options "-O2 -ffast-math -std=c++20 -save-temps" }
-// { dg-final { scan-assembler-not "'\tucomisd" { target { ! ia32 } } } }
-// { dg-final { scan-assembler-times "\tcomisd" 2 { target { ! ia32 } } } }
+// { dg-final { scan-assembler-not "'\t\[v\]?ucomisd" { target { ! ia32 } } } }
+// { dg-final { scan-assembler-times "\t\[v\]?comisd" 2 { target { ! ia32 } } } }
 
 #include <compare>
 
diff --git a/gcc/testsuite/g++.target/i386/pr103973-7.C b/gcc/testsuite/g++.target/i386/pr103973-7.C
index 17579610475..0e05b8e87b5 100644
--- a/gcc/testsuite/g++.target/i386/pr103973-7.C
+++ b/gcc/testsuite/g++.target/i386/pr103973-7.C
@@ -1,8 +1,8 @@
 // PR target/103973
 // { dg-do run }
 // { dg-options "-O2 -ffast-math -save-temps -std=c++20" }
-// { dg-final { scan-assembler-not "'\tucomiss" { target { ! ia32 } } } }
-// { dg-final { scan-assembler-times "\tcomiss" 2 { target { ! ia32 } } } }
+// { dg-final { scan-assembler-not "'\t\[v\]?ucomiss" { target { ! ia32 } } } }
+// { dg-final { scan-assembler-times "\t\[v\]?comiss" 2 { target { ! ia32 } } } }
 
 #define double_type float
 #include "pr103973-5.C"
diff --git a/gcc/testsuite/g++.target/i386/pr103973-9.C b/gcc/testsuite/g++.target/i386/pr103973-9.C
index deb48f93d9b..23a179178aa 100644
--- a/gcc/testsuite/g++.target/i386/pr103973-9.C
+++ b/gcc/testsuite/g++.target/i386/pr103973-9.C
@@ -1,8 +1,8 @@
 // PR target/103973
 // { dg-do run }
 // { dg-options "-O2 -std=c++20 -save-temps" }
-// { dg-final { scan-assembler-not "'\tucomisd" { target { ! ia32 } } } }
-// { dg-final { scan-assembler-times "\tcomisd" 2 { target { ! ia32 } } } }
+// { dg-final { scan-assembler-not "'\t\[v\]?ucomisd" { target { ! ia32 } } } }
+// { dg-final { scan-assembler-times "\t\[v\]?comisd" 2 { target { ! ia32 } } } }
 
 #include <compare>
 
diff --git a/gcc/testsuite/gcc.target/i386/pr103973-1.c b/gcc/testsuite/gcc.target/i386/pr103973-1.c
index d0a3bc2339b..2857a4f0e83 100644
--- a/gcc/testsuite/gcc.target/i386/pr103973-1.c
+++ b/gcc/testsuite/gcc.target/i386/pr103973-1.c
@@ -1,8 +1,8 @@
 /* PR target/103973 */
 /* { dg-do run } */
 /* { dg-options "-O2 -save-temps" } */
-/* { dg-final { scan-assembler-not "'\tucomisd" { target { ! ia32 } } } } */
-/* { dg-final { scan-assembler-times "\tcomisd" 4 { target { ! ia32 } } } } */
+/* { dg-final { scan-assembler-not "'\t\[v\]?ucomisd" { target { ! ia32 } } } } */
+/* { dg-final { scan-assembler-times "\t\[v\]?comisd" 4 { target { ! ia32 } } } } */
 
 __attribute__((noipa)) int m1 (void) { return -1; }
 __attribute__((noipa)) int p0 (void) { return 0; }
diff --git a/gcc/testsuite/gcc.target/i386/pr103973-11.c b/gcc/testsuite/gcc.target/i386/pr103973-11.c
index a906d140e48..343350ce8ba 100644
--- a/gcc/testsuite/gcc.target/i386/pr103973-11.c
+++ b/gcc/testsuite/gcc.target/i386/pr103973-11.c
@@ -1,8 +1,8 @@
 /* PR target/103973 */
 /* { dg-do run } */
 /* { dg-options "-O2 -save-temps" } */
-/* { dg-final { scan-assembler-not "'\tucomiss" { target { ! ia32 } } } } */
-/* { dg-final { scan-assembler-times "\tcomiss" 4 { target { ! ia32 } } } } */
+/* { dg-final { scan-assembler-not "\t\[v\]?ucomiss" { target { ! ia32 } } } } */
+/* { dg-final { scan-assembler-times "\t\[v\]?comiss" 4 { target { ! ia32 } } } } */
 
 #define double float
 #include "pr103973-9.c"
diff --git a/gcc/testsuite/gcc.target/i386/pr103973-13.c b/gcc/testsuite/gcc.target/i386/pr103973-13.c
index 7e6dc4043cb..4c97612bccf 100644
--- a/gcc/testsuite/gcc.target/i386/pr103973-13.c
+++ b/gcc/testsuite/gcc.target/i386/pr103973-13.c
@@ -1,8 +1,8 @@
 /* PR target/103973 */
 /* { dg-do run } */
 /* { dg-options "-O2 -ffast-math -save-temps" } */
-/* { dg-final { scan-assembler-not "'\tucomisd" { target { ! ia32 } } } } */
-/* { dg-final { scan-assembler-times "\tcomisd" 4 { target { ! ia32 } } } } */
+/* { dg-final { scan-assembler-not "'\t\[v\]?ucomisd" { target { ! ia32 } } } } */
+/* { dg-final { scan-assembler-times "\t\[v\]?comisd" 4 { target { ! ia32 } } } } */
 
 __attribute__((noipa)) int m1 (void) { return -1; }
 __attribute__((noipa)) int p0 (void) { return 0; }
diff --git a/gcc/testsuite/gcc.target/i386/pr103973-15.c b/gcc/testsuite/gcc.target/i386/pr103973-15.c
index 3b65a131ea5..c455ad73dd0 100644
--- a/gcc/testsuite/gcc.target/i386/pr103973-15.c
+++ b/gcc/testsuite/gcc.target/i386/pr103973-15.c
@@ -1,8 +1,8 @@
 /* PR target/103973 */
 /* { dg-do run } */
 /* { dg-options "-O2 -ffast-math -save-temps" } */
-/* { dg-final { scan-assembler-not "'\tucomiss" { target { ! ia32 } } } } */
-/* { dg-final { scan-assembler-times "\tcomiss" 4 { target { ! ia32 } } } } */
+/* { dg-final { scan-assembler-not "'\t\[v\]?ucomiss" { target { ! ia32 } } } } */
+/* { dg-final { scan-assembler-times "\t\[v\]?comiss" 4 { target { ! ia32 } } } } */
 
 #define double float
 #include "pr103973-13.c"
diff --git a/gcc/testsuite/gcc.target/i386/pr103973-3.c b/gcc/testsuite/gcc.target/i386/pr103973-3.c
index 2b9124e998c..f7eb887c7b8 100644
--- a/gcc/testsuite/gcc.target/i386/pr103973-3.c
+++ b/gcc/testsuite/gcc.target/i386/pr103973-3.c
@@ -1,8 +1,8 @@
 /* PR target/103973 */
 /* { dg-do run } */
 /* { dg-options "-O2 -save-temps" } */
-/* { dg-final { scan-assembler-not "'\tucomiss" { target { ! ia32 } } } } */
-/* { dg-final { scan-assembler-times "\tcomiss" 4 { target { ! ia32 } } } } */
+/* { dg-final { scan-assembler-not "'\t\[v\]?ucomiss" { target { ! ia32 } } } } */
+/* { dg-final { scan-assembler-times "\t\[v\]?comiss" 4 { target { ! ia32 } } } } */
 
 #define double float
 #include "pr103973-1.c"
diff --git a/gcc/testsuite/gcc.target/i386/pr103973-5.c b/gcc/testsuite/gcc.target/i386/pr103973-5.c
index 9ee6ca23ee0..2fa6be21e62 100644
--- a/gcc/testsuite/gcc.target/i386/pr103973-5.c
+++ b/gcc/testsuite/gcc.target/i386/pr103973-5.c
@@ -1,8 +1,8 @@
 /* PR target/103973 */
 /* { dg-do run } */
 /* { dg-options "-O2 -ffast-math -save-temps" } */
-/* { dg-final { scan-assembler-not "'\tucomisd" { target { ! ia32 } } } } */
-/* { dg-final { scan-assembler-times "\tcomisd" 4 { target { ! ia32 } } } } */
+/* { dg-final { scan-assembler-not "'\t\[v\]?ucomisd" { target { ! ia32 } } } } */
+/* { dg-final { scan-assembler-times "\t\[v\]?comisd" 4 { target { ! ia32 } } } } */
 
 __attribute__((noipa)) int m1 (void) { return -1; }
 __attribute__((noipa)) int p0 (void) { return 0; }
diff --git a/gcc/testsuite/gcc.target/i386/pr103973-7.c b/gcc/testsuite/gcc.target/i386/pr103973-7.c
index b883f8c5307..cf3759e883f 100644
--- a/gcc/testsuite/gcc.target/i386/pr103973-7.c
+++ b/gcc/testsuite/gcc.target/i386/pr103973-7.c
@@ -1,8 +1,8 @@
 /* PR target/103973 */
 /* { dg-do run } */
 /* { dg-options "-O2 -ffast-math -save-temps" } */
-/* { dg-final { scan-assembler-not "'\tucomiss" { target { ! ia32 } } } } */
-/* { dg-final { scan-assembler-times "\tcomiss" 4 { target { ! ia32 } } } } */
+/* { dg-final { scan-assembler-not "'\t\[v\]?ucomiss" { target { ! ia32 } } } } */
+/* { dg-final { scan-assembler-times "\t\[v\]?comiss" 4 { target { ! ia32 } } } } */
 
 #define double float
 #include "pr103973-5.c"
diff --git a/gcc/testsuite/gcc.target/i386/pr103973-9.c b/gcc/testsuite/gcc.target/i386/pr103973-9.c
index cc583c0e286..5c623f54458 100644
--- a/gcc/testsuite/gcc.target/i386/pr103973-9.c
+++ b/gcc/testsuite/gcc.target/i386/pr103973-9.c
@@ -1,8 +1,8 @@
 /* PR target/103973 */
 /* { dg-do run } */
 /* { dg-options "-O2 -save-temps" } */
-/* { dg-final { scan-assembler-not "'\tucomisd" { target { ! ia32 } } } } */
-/* { dg-final { scan-assembler-times "\tcomisd" 4 { target { ! ia32 } } } } */
+/* { dg-final { scan-assembler-not "'\t\[v\]?ucomisd" { target { ! ia32 } } } } */
+/* { dg-final { scan-assembler-times "\t\[v\]?comisd" 4 { target { ! ia32 } } } } */
 
 __attribute__((noipa)) int m1 (void) { return -1; }
 __attribute__((noipa)) int p0 (void) { return 0; }